//
// ù׻
//
//	2003.5.6	8Τߤξλĺ׻ΥХ

#include <statcomp.h>
#include <tool.h>
#include "renormal.h"
#include "correct.h"
#include "pdp.h"

//
// ù׻ɸа̷׻
//
double
CalcFundMatrix(ImagePosition P1[], ImagePosition P2[], int data_num,
	       VectorN& eigen_val, Matrix* eigen_mat,
	       double& e_hat2, Matrix& F, Matrix& F_p, Matrix& F_m,
	       int dim, double mineps, int itmax, int pdpflg)
{
   int		ret;
   double	J;
   Tensor3333	V_0F;
   Vector	x1, x2;
   Matrix	V1, V2;

   //ꤳˡˤù
   ret = Renormal(P1, P2, data_num, eigen_val, eigen_mat, J,
		  dim, mineps, itmax);

   if (!ret)
   {
      fprintf(stderr, "Error: renormalization procedure failed\n");
      return -1.0;
   }

   //ùಽȽ
   J = fabs(J);
   if (data_num == 8)	// Υ٥ϵޤʤ(2002.11.25)
      e_hat2 = 0.0;
   else
      e_hat2 = J/(1.0 - 8.0/(double)data_num); //Υ٥ο

   if (e_hat2 > eigen_val[7]*data_num)
   {
      fprintf(stderr, "Warning: Degeneracy!\n");
      return -1.0;
   }

   //ŬԤʤ
   /******M_hatκǾͭͤбͭFȤ******/
   F = eigen_mat[8]; 

   /******Fʬƥ󥽥V_0F׻******/
   V_0F.clear(0.0);
   for (int a = 0; a < 8; a++)
   {
      eigen_val[a] = eigen_val[a]/eigen_val[7];
      V_0F = V_0F + TensorProduct(eigen_mat[a], eigen_mat[a])/eigen_val[a];
   }
   V_0F = V_0F/(double)data_num;
   
   /****** FdetF=0Ȥʤ褦 ******/
//   F.LongPrint(stdout, "original F = ");
   F = Correct(F, V_0F, 1.0e-12);
//   F.LongPrint(stdout, "corrected F = ");

   /****** ɸа̤ο ******/
   if (pdpflg)
   {
      double	J;
      Matrix	Ft = Trans(F);

      /****** ǡ 8 ĤΤߤξϥΥ٥ƿ ******/
      if (data_num == 8)
      {
	 J = 0.0;
	 for (int a = 0; a < data_num; a++)
	 {
	    //֤٥ȥȶʬ
	    x1 = P1[a].Pos();      V1 = P1[a].Cov();
	    x2 = P2[a].Pos();      V2 = P2[a].Cov();      
	    
	    // ĺκƷ׻
	    // Х(2003.5.6)
	    J += ((x1, (F * x2)) * (x1, (F * x2)))
	       / ((x2, (Ft*V1*F*x2)) + (x1, (F*V2*Ft*x1)));
	 }

	 e_hat2 = J / (1.0 - 7.0 / data_num);
      }

      // ɸа̷׻Ԥ
      PDP(data_num, eigen_val, eigen_mat, e_hat2, F, F_p, F_m);
   }

   return J;
}
