//----------------------------------------------------------------------//
//  Correct: optimal correction for fundamental matrix                  //
//                                                                      //
//  2000/2/29                                                           //
//  Programmed by Hitoshi Mishima                                       //
//  Department of Computer Science,                                     //
//  Gunma University Faculty of Engineering                             //
//----------------------------------------------------------------------//
// 2002/11/25  Ŭζʬ󹹿ΥХեå			//
//----------------------------------------------------------------------//

#include <statcomp.h>
#include <tool.h>
#include "extra.h"
#include "correct.h"

Matrix
Correct(Matrix F, Tensor3333 V_0F, double eps_d)
//----------------------------------------------------------------------//
//ǽ                                                                  //
//  ùFȤʬƥ󥽥Ϳ, FdetF=0Ȥʤ褦	//
//  Ŭ. 							//
//									//
//                                                                  //
//  F      : ù                         input			//
//  V_0F   : Fʬƥ󥽥          input			//
//  eps_d  : ȿλ                     input			//
//            (ǥե: 1.0e-12)					//
//									//
//֤								//
//  ù							//
//----------------------------------------------------------------------//
{
   int		iter = 0;
   Matrix	F_trs, T_prd, co_F = F;
   Tensor3333	P, v0fp, v0f = V_0F;

   while (fabs(Det(co_F)) > eps_d)
   {
      iter++;
      if (iter > CRR_MAX_ITR) 
      {
	 fprintf(stderr, "Iteration exceeded %d times.\n", CRR_MAX_ITR);
	 exit(1);
      }

      //co_F򹹿
      F_trs = Trans(Cofactor(co_F));
      T_prd = v0f * F_trs;
      co_F = Normalize(co_F - Det(co_F)*T_prd/(F_trs, T_prd));

      //co_Fμͱƥƥ󥽥P׻
      P = ProjTensor(co_F);

      //co_Fʬƥ󥽥v0f򹹿
      v0fp = v0f;	//  v0f ¸
      for (int i = 0; i < 3; i++)
	 for (int j = 0; j < 3; j++)
	    for (int k = 0; k < 3; k++)
	       for (int l = 0; l < 3; l++)
		  for (int m = 0; m < 3; m++)
		     for (int n = 0; n < 3; n++)
			for (int p = 0; p < 3; p++)
			   for (int q = 0; q < 3; q++)
			   {
			      v0f(i,j,k,l)
				 += P(i,j,m,n) * P(k,l,p,q) * v0fp(m,n,p,q);
			   }
   }

   return co_F;
}
