//
// ꤳˡˤùȤɸа̤κŬ׻
//
// Usage: fundamental file1 file2
// 
//      flie1  : ưpixelɸ        ascii-file
//      file2  : ưpixelɸ        ascii-file
//
// [2002.11.25]	 by ߷
//	ħ8ĤξǤ褦ѹ
//	ùϤ LongPrint ѹ

#define MAIN

#include <unistd.h>

#include <statcomp.h>
#include <tool.h>

#include "renormal.h"
#include "pdp.h"
#include "correct.h"
#include "extra.h"
#include "filedeal.h"
#include "misc.h"
#include "calcfundmat.h"

int
main(int argc, char *argv[])
{
   static char	usg[] = "Usage: %s [-p] file1 file2\n";
   static char	msg[] = "%s: Data number disagreement!\n";
   char		file1[80], file2[80];
   int		data_num, data_num2, dim, itmax;
   double	**d1, **d2;
   VectorN	eigen_val(9);
   Matrix	eigen_mat[9], F_hat, F_p, F_m, c_F;
   double	J, e_hat2, mineps, f0;
   double	xm1, ym1, Lx1, Ly1, xm2, ym2, Lx2, Ly2;
   Matrix	A1, A2, A1t;		// ɸѴѹ
   ImagePosition	*P1, *P2;	// ħ
   int	       	pdpflg;
   int		opt;

   data_num = data_num2 = 0;
   xm1 = ym1 = Lx1 = Ly1 = xm2 = ym2 = Lx2 = Ly2 = 0.0;
   f0 = 600.0; dim = 1; itmax = 50; mineps = 1.0e-10;
   pdpflg = 0;

   // ץ
   while ((opt = getopt(argc, argv, "p")) != -1)
   {
      switch (opt)
      {
	case 'p':
	   pdpflg = 1;
      }
   }

   if (optind < argc)
   {
      strcpy(file1, argv[optind++]);
      strcpy(file2, argv[optind++]);
   }
   else
   {
      fprintf(stderr, usg, argv[0]); 
      exit(1);
   }

   //ɸեɤ߹ߤʤѴν
   Text2(file1, d1, data_num,  xm1, ym1, Lx1, Ly1); //ư
   Text2(file2, d2, data_num2, xm2, ym2, Lx2, Ly2); //ư

   if (data_num < 8)
   {
      fprintf(stderr, "Error: data number is less than 8.\n");
      exit(1);
   }
   if (data_num != data_num2)
   {
      fprintf(stderr, msg, argv[0]);
      exit(1);
   }

   // ǥեȾΥη׻
   f0 = DefaultFocalLength(Lx1, Ly1, Lx2, Ly2);

   // ImagePosition ؤѴ
   P1 = new ImagePosition [data_num];
   P2 = new ImagePosition [data_num];
   MakeImagePositions(P1, d1, data_num, f0, xm1, ym1);
   MakeImagePositions(P2, d2, data_num, f0, xm2, ym2);

   // ϥեޥåѴѹA1, A2η׻
   A1 = ConvMatrix(f0, xm1, ym1);
   A2 = ConvMatrix(f0, xm2, ym2);
   A1t = Trans(A1);

   // ù׻
   J = CalcFundMatrix(P1, P2, data_num, eigen_val, eigen_mat,
		      e_hat2, c_F, F_p, F_m,
		      dim, mineps, itmax, pdpflg);

   if (J < 0.0)
      return 1;	// 

   // ɸϤѴȽ
   c_F = Normalize(A1t * c_F * A2);
   c_F.LongPrint(stdout, "F  = ");
   printf("\n");

   // ɸа
   if (pdpflg)
   {
      F_p = Normalize(A1t * F_p * A2);
      F_p.LongPrint(stdout, "F+ = ");
      printf("\n");
      F_m = Normalize(A1t * F_m * A2);
      F_m.LongPrint(stdout, "F- = ");
      printf("\n");
   }

   return 0;
}
