//----------------------------------------------------------------------//
//  PDP: calculate primary deviation pair of fundamental matrix         //
//                                                                      //
//  1999/2/12                                                           //
//  Programmed by Hitoshi Mishima                                       //
//  Department of Computer Science,                                     //
//  Gunma University Faculty of Engineering                             //
//----------------------------------------------------------------------//

#ifndef _pdp_h_
#define _pdp_h_

void PDP(int point_num, VectorN eigen_vec, Matrix* eigen_mat, 
	 double e_hat2, Matrix& F, Matrix& F_plus, Matrix& F_minus, 
	 double d_eps = 1.0e-12, int crr_flag = 1);
//----------------------------------------------------------------------//
//ǽ                                                                  //
//  ⡼ȥƥ󥽥9Ĥθͭͤбñ̸ͭľ,  //
//  ڤΥ٥οͤͿ, ŬùFȤ   //
//  ɸа(primary deviation pair) F_plus, F_minus֤.             //
//                                                                      //
//                                                                  //
//  point_num : ǡ                              input		//
//  eigen_vec : ⡼ȥƥ󥽥θͭ              input		//
//  eigen_mat : eigen_valбͭ             input		//
//  e_hat2    : Υ٥ο                input		//
//  F         : ù                        output		//
//  F_plus    : Fɸа(+)                          output		//
//  F_minus   : F      (-)                          output		//
//  eps_d     : ȿλ                            input		//
//              (ǥե: 1.0e-12)					//
//  crr_flag  : Ŭ¹ԥե饰                      input		//
//              (=1ʤFκŬ¹, ǥե: 1)		//
//----------------------------------------------------------------------//


#endif //_pdp_h_
